/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   constraint_ordering.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_CONSTRAINT_ORDERING_H
#define UHDM_CONSTRAINT_ORDERING_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>




namespace UHDM {


class constraint_ordering final : public BaseClass {
  UHDM_IMPLEMENT_RTTI(constraint_ordering, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: constraint_ordering();
  virtual ~constraint_ordering() final = default;

  VectorOfexpr* Solve_befores() const { return solve_befores_; }
  bool Solve_befores(VectorOfexpr* data) {
    solve_befores_ = data;
    return true;
  }

  VectorOfexpr* Solve_afters() const { return solve_afters_; }
  bool Solve_afters(VectorOfexpr* data) {
    solve_afters_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiConstraintOrdering; }

  virtual constraint_ordering* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmconstraint_ordering; }

protected:
  void DeepCopy(constraint_ordering* clone, BaseClass* parent, CloneContext* context) const;

private:
  VectorOfexpr* solve_befores_ = nullptr;

  VectorOfexpr* solve_afters_ = nullptr;
};


typedef FactoryT<constraint_ordering> constraint_orderingFactory;


typedef FactoryT<std::vector<constraint_ordering *>> VectorOfconstraint_orderingFactory;

}  // namespace UHDM

#endif
