/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   if_else.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_IF_ELSE_H
#define UHDM_IF_ELSE_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/atomic_stmt.h>

#include "stmt.h"


namespace UHDM {
class expr;

class if_else final : public atomic_stmt {
  UHDM_IMPLEMENT_RTTI(if_else, atomic_stmt)
public:
  // Implicit constructor used to initialize all members,
  // comment: if_else();
  virtual ~if_else() final = default;

  int32_t VpiQualifier() const { return vpiQualifier_; }
  bool VpiQualifier(int32_t data) {
    vpiQualifier_ = data;
    return true;
  }

  expr* VpiCondition()  { return vpiCondition_; }
  const expr* VpiCondition() const { return vpiCondition_; }
  template <typename T>
  T* VpiCondition() {
    return (vpiCondition_ == nullptr) ? nullptr : any_cast<T*>(vpiCondition_);
  }
  template <typename T>
  const T* VpiCondition() const {
    return (vpiCondition_ == nullptr) ? nullptr : any_cast<const T*>(vpiCondition_);
  }
  bool VpiCondition(expr* data) {
    vpiCondition_ = data;
    return true;
  }

  any* VpiStmt()  { return vpiStmt_; }
  const any* VpiStmt() const { return vpiStmt_; }
  template <typename T>
  T* VpiStmt() {
    return (vpiStmt_ == nullptr) ? nullptr : any_cast<T*>(vpiStmt_);
  }
  template <typename T>
  const T* VpiStmt() const {
    return (vpiStmt_ == nullptr) ? nullptr : any_cast<const T*>(vpiStmt_);
  }
  bool VpiStmt(any* data) {
    if (!stmtGroupCompliant(data)) return false;
    vpiStmt_ = data;
    return true;
  }

  any* VpiElseStmt()  { return vpiElseStmt_; }
  const any* VpiElseStmt() const { return vpiElseStmt_; }
  template <typename T>
  T* VpiElseStmt() {
    return (vpiElseStmt_ == nullptr) ? nullptr : any_cast<T*>(vpiElseStmt_);
  }
  template <typename T>
  const T* VpiElseStmt() const {
    return (vpiElseStmt_ == nullptr) ? nullptr : any_cast<const T*>(vpiElseStmt_);
  }
  bool VpiElseStmt(any* data) {
    if (!stmtGroupCompliant(data)) return false;
    vpiElseStmt_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiIfElse; }

  virtual if_else* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmif_else; }

protected:
  void DeepCopy(if_else* clone, BaseClass* parent, CloneContext* context) const;

private:
  int32_t vpiQualifier_ = 0;

  expr* vpiCondition_ = nullptr;

  any* vpiStmt_ = nullptr;

  any* vpiElseStmt_ = nullptr;
};


typedef FactoryT<if_else> if_elseFactory;


typedef FactoryT<std::vector<if_else *>> VectorOfif_elseFactory;

}  // namespace UHDM

#endif
