/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   task_call.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_TASK_CALL_H
#define UHDM_TASK_CALL_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/tf_call.h>




namespace UHDM {
class task;

class task_call final : public tf_call {
  UHDM_IMPLEMENT_RTTI(task_call, tf_call)
public:
  // Implicit constructor used to initialize all members,
  // comment: task_call();
  virtual ~task_call() final = default;

  task* Task()  { return task_; }
  const task* Task() const { return task_; }
  template <typename T>
  T* Task() {
    return (task_ == nullptr) ? nullptr : any_cast<T*>(task_);
  }
  template <typename T>
  const T* Task() const {
    return (task_ == nullptr) ? nullptr : any_cast<const T*>(task_);
  }
  bool Task(task* data) {
    task_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiTaskCall; }

  virtual tf_call* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmtask_call; }

protected:
  void DeepCopy(task_call* clone, BaseClass* parent, CloneContext* context) const;

private:
  task* task_ = nullptr;
};


typedef FactoryT<task_call> task_callFactory;


typedef FactoryT<std::vector<task_call *>> VectorOftask_callFactory;

}  // namespace UHDM

#endif
